//R-BUS-NANO-G++
//групповой модуль обратной связи на MCP23017, 80 (160) адресов
//+ логика для создания хитрых, "интеллектуальных" датчиков
//+ пульт для настройки
#include <Arduino.h>
#include <avr/interrupt.h>
#include <Wire.h>
#include <LiquidCrystal_I2C.h>  //библиотека экрана

// when sending data, do NOT continue until the hardware has sent the data out
#define WAIT_FOR_XMIT_COMPLETE {while (!(UCSR0A & (1<<TXC0))); UCSR0A = (1<<TXC0); UCSR0A = 0;}

//Interrupt routine for reading via Serial
ISR(USART_RX_vect) {
handle_interrupt();  //weiterreichen an die Funktion
}

LiquidCrystal_I2C lcd(0x27, 16, 2);  //Устанавливаем дисплей, встречались контроллеры с адресами 0x3F 0x27

unsigned int XNetMsg[15];    //Serial receive (Length, Message, Command, Data1 to Data12)

#define XNetlength  0		//Length
#define XNetmsg     1		//Message         0x1DE Call Bytes
#define XNetcom     2		//Command         0xFC
#define XNetdata1   3		//Databyte1       Group
#define XNetdata2   4		//Databyte2       1
#define XNetdata3   5		//Databyte3       2
#define XNetdata4   6		//Databyte4       3
#define XNetdata5   7		//Databyte5       4
#define XNetdata6   8		//Databyte6       5
#define XNetdata7   9		//Databyte7       6
#define XNetdata8  10		//Databyte8       7
#define XNetdata9  11		//Databyte9       8
#define XNetdata10 12		//Databyte10      9
#define XNetdata11 13		//Databyte11      10
#define XNetdata12 14		//Databyte12      negiertes XOR-Byte

byte n = 0;
boolean ReadData = false;
volatile bool sfb = false;
byte StatusByte[16] = {1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1}; //Read data
byte Setup7219[10] = {0x0F, 0x00, // Тест индикатора выключен
                      0x0C, 0x01, // Выйти из сна
                      0x09, 0x00, // Дешифраторы отключены
                      0x0B, 0x07, // Кол-во задействованных символов (0..7)
                      0x0A, 0x01}; // Интенсивность свечения (яркость) (0..15)
byte group = 0x10;            // группа адресов: 0x00 для 1-10, 0x10 для 11-20
unsigned long currentMillis = 0;
const byte mcp_address[5] = {0x20, 0x21, 0x22, 0x23, 0x24}; // I2C Address of chip MCP23017

volatile bool inLCD = 0;  //флаг наличия дисплея и энкодера
volatile bool inNext = 0;  //флаг "переход к следующему адресу"
volatile byte menuNum = 0;  //номер пункта меню: 
boolean ir0 = false; //старое значение датчика 0
boolean ir1 = false; //старое значение датчика 1
byte ircnt = 0; //счётчик для сброса сигнала

// - - - S E T - - -
//--------------------------
#define MAX485_CONTROL 9  // Port for send or receive control (Control PIN)
#define DATA_PIN    5    // DS пин данных (англ. data)    DIN
#define SELECT_PIN  6    // QE пин выбора (англ. select)
#define LATCH_PIN   7    // ST пин строба (англ. latch)   CS
#define CLOCK_PIN   8    // SH пин такта (англ. clock)    CLC
//-------------------------
// S E T U P
//--------------------------------------------------------------------------------------------
void setup() {
  
/* Init the digital pins. */
  pinMode(MAX485_CONTROL, OUTPUT);
  pinMode(DATA_PIN, OUTPUT);
  pinMode(CLOCK_PIN, OUTPUT);
  pinMode(SELECT_PIN, OUTPUT);
  pinMode(LATCH_PIN, OUTPUT);
  digitalWrite (MAX485_CONTROL, LOW);

  int ar = analogRead(17);
  if( ar < 600 )  //если на входе земля
  {
    inLCD = 1;  //ставим флаг
    lcd.init();  //инициализация дисплея                   
//    lcd.createChar(0, newChar0);  //загружаем спец.символы
//    lcd.createChar(1, newChar1);
    lcd.setBacklight(true);
    lcd.clear();    
    lcd.setCursor(4, 1);
    lcd.print(ar);
    pinMode(2, INPUT);  //вход кнопки энкодера
    pinMode(3, INPUT);  //вход 1 ручки энкодера
    pinMode(4, INPUT);  //вход 2 ручки энкодера
//    attachInterrupt(0, EncoderButton, FALLING);  //включаем прерывание от кнопки энкодера
  }

// - - -
// - - -
  Wire.begin();           // join i2c bus
  mcp_write(0x20, 0x00, 0xFF); //IODIRA register, set GPIOA to inputs
  mcp_write(0x20, 0x01, 0xFF); //IODIRB register, set GPIOB to inputs
  mcp_write(0x20, 0x02, 0xFF); //IPOLA register, set IPOLA to opposite logic of the input pin
  mcp_write(0x20, 0x03, 0xFF); //IPOLB register, set IPOLB to opposite logic of the input pin
  mcp_write(0x20, 0x0C, 0xFF); //GPPUA register, подтяжка входов к +
  mcp_write(0x20, 0x0D, 0xFF); //GPPUB register, подтяжка входов к +
  mcp_write(0x21, 0x00, 0xFF); //IODIRA register, set GPIOA to inputs
  mcp_write(0x21, 0x01, 0xFF); //IODIRB register, set GPIOB to inputs
  mcp_write(0x21, 0x02, 0xFF); //IPOLA register, set IPOLA to opposite logic of the input pin
  mcp_write(0x21, 0x03, 0xFF); //IPOLB register, set IPOLB to opposite logic of the input pin
  mcp_write(0x21, 0x0C, 0xFF); //GPPUA register, подтяжка входов к +
  mcp_write(0x21, 0x0D, 0xFF); //GPPUB register, подтяжка входов к + */
/*  for(byte i = 0; i < 5; i++) {
    mcp_write(mcp_address[i], 0x00, 0xFF); //IODIRA register, set GPIOA to inputs
    mcp_write(mcp_address[i], 0x01, 0xFF); //IODIRB register, set GPIOB to inputs
    mcp_write(mcp_address[i], 0x02, 0xFF); //IPOLA register, set IPOLA to opposite logic of the input pin
    mcp_write(mcp_address[i], 0x03, 0xFF); //IPOLB register, set IPOLB to opposite logic of the input pin
    mcp_write(mcp_address[i], 0x0C, 0xFF); //GPPUA register, подтяжка входов к +
    mcp_write(mcp_address[i], 0x0D, 0xFF); //GPPUB register, подтяжка входов к +
  }/*/

  for(byte i = 0; i < 5; i++) {
    digitalWrite(LATCH_PIN, LOW); // 
    shiftOut(DATA_PIN, CLOCK_PIN, MSBFIRST, Setup7219[i * 2]); // adres
    shiftOut(DATA_PIN, CLOCK_PIN, MSBFIRST, Setup7219[i * 2 + 1]); // comand
    shiftOut(DATA_PIN, CLOCK_PIN, MSBFIRST, Setup7219[i * 2]); // adres
    shiftOut(DATA_PIN, CLOCK_PIN, MSBFIRST, Setup7219[i * 2 + 1]); // comand
    digitalWrite(LATCH_PIN, HIGH);   // 
    delayMicroseconds(2);
  }
  for(byte i = 0; i < 8; i++) {
    digitalWrite(LATCH_PIN, LOW); // 
    shiftOut(DATA_PIN, CLOCK_PIN, MSBFIRST, i + 1); // adres
    shiftOut(DATA_PIN, CLOCK_PIN, MSBFIRST, 0); // clear
    shiftOut(DATA_PIN, CLOCK_PIN, MSBFIRST, i + 1); // adres
    shiftOut(DATA_PIN, CLOCK_PIN, MSBFIRST, 0); // clear
    digitalWrite(LATCH_PIN, HIGH);   // 
    delayMicroseconds(2);
  }
  
  for(byte j = 0; j < 9; j++) { //бегущий огонь для проверки 
    led_write();
    delay(250);
    for(byte i = 0; i < 16; i++) {
      StatusByte[i] = StatusByte[i] << 1;
    }
  }
  
  for(byte i = 0; i < 16; i++) {
    StatusByte[i] = i; //((i + 1) | group); //адрес модуля
  }
  led_write(); 
  for(byte i = 0; i < 16; i++) {
    StatusByte[i] = 0;
  }
  delay(3000);
  XNetclear();
  start();
  currentMillis = millis();
}
// end of SETUP

// L O O P
//--------------------------------------------------------------------------------------------
void loop() {
  if (sfb == true || (millis() - currentMillis) > 50 ) {
    sfb = false;
    get_status();
    led_write();
    currentMillis = millis();
  }
}
// end of L O O P
//--------------------------------------------------------------------------------------------
void(* resetFunc) (void) = 0; // Reset MC function

void get_status() //чтение датчиков
{
  StatusByte[0] = mcp_read(0x20, 0x13); // B before A
  StatusByte[1] = mcp_read(0x20, 0x12); 
  StatusByte[2] = mcp_read(0x21, 0x13); // B before A
  StatusByte[3] = mcp_read(0x21, 0x12); 

  if(ircnt-- < 1) { //гасим сигнал сработки датчиков 1-0 по истечении времени
    bitClear(StatusByte[9], 0);
    ircnt = 0;
  }
  if(!bitRead(StatusByte[0], 0) && ir0 && !ir1) { //если состав прошёл над датчиками 1 затем 0
    bitSet(StatusByte[9], 0); //зажигаем индикатор сработки датчиков 1-0
    ircnt = 20; //длительность сигнала сработки датчиков 1-0
  }
  if(bitRead(StatusByte[0], 0)) ir0 = true; //запоминаем состояние датчика 0
  else ir0 = false;
  if(bitRead(StatusByte[0], 1)) ir1 = true; //запоминаем состояние датчика 1
  else ir1 = false;
/*  for(byte i = 0; i < 8; i++) {
    StatusByte[i * 2] = mcp_read(mcp_address[0x20 + i], 0x13);
    StatusByte[i * 2 + 1] = mcp_read(mcp_address[0x20 + i], 0x12);
  }/*/
}

void led_write() //зажигаем
{
  for(byte i = 0; i < 8; i++) {
    digitalWrite(LATCH_PIN, LOW); // 
    shiftOut(DATA_PIN, CLOCK_PIN, MSBFIRST, i + 1); //
    shiftOut(DATA_PIN, CLOCK_PIN, MSBFIRST, StatusByte[i] + n); //
    shiftOut(DATA_PIN, CLOCK_PIN, MSBFIRST, i + 1); //
    shiftOut(DATA_PIN, CLOCK_PIN, MSBFIRST, StatusByte[i + 8] + n); //
    digitalWrite(LATCH_PIN, HIGH);   //
  }
}

void mcp_write(byte mcp_addr, byte mcp_reg, byte mcp_set) //запись регистров MCP23017
{
  Wire.beginTransmission(mcp_addr); //адрес MCP23017
  Wire.write(mcp_reg);       // регистр MCP23017
  Wire.write(mcp_set);       // установки
  Wire.endTransmission();  
}

byte mcp_read(byte mcp_addr, byte mcp_reg) //чтение датчиков из MCP23017
{
  Wire.beginTransmission(mcp_addr);
  Wire.write(mcp_reg); // set MCP23017 memory pointer to GPIO address
  Wire.endTransmission();
  Wire.requestFrom(mcp_addr, 1); // request one byte of data from MCP23017
  byte result = Wire.read(); // store the incoming byte into "inputs"
  return result;
}

//Delete the last transmitted command
void XNetclear() 
{
  XNetMsg[XNetlength] = 0x00;
  XNetMsg[XNetmsg] = 0x00;
  XNetMsg[XNetcom] = 0x00;
  XNetMsg[XNetdata1] = 0x00;
  XNetMsg[XNetdata2] = 0x00;
  XNetMsg[XNetdata3] = 0x00;
  XNetMsg[XNetdata4] = 0x00;
  XNetMsg[XNetdata5] = 0x00;
  XNetMsg[XNetdata6] = 0x00;
  XNetMsg[XNetdata7] = 0x00;
  XNetMsg[XNetdata8] = 0x00;
  XNetMsg[XNetdata9] = 0x00;
  XNetMsg[XNetdata10] = 0x00;
  XNetMsg[XNetdata11] = 0x00;
  XNetMsg[XNetdata12] = 0x00;
}

//******************************************Serial*******************************************
void start()  //Serial initialization
{
  //Set up on 62500 Baud
  cli();  //disable interrupts while initializing the USART
  UBRR0H = 0;
  UBRR0L = 0x0F;
  UCSR0A = 0;
  UCSR0B = (1<<RXEN0) | (1<<TXEN0) | (1<<RXCIE0) | (1<<UCSZ02);
  UCSR0C = (1<<UCSZ01) | (1<<UCSZ00);
  sei(); // Enable the Global Interrupt Enable flag so that interrupts can be processed 
}

//--------------------------------------------------------------------------------------------
int USART_Receive(void)
{
  unsigned char status, resh, resl;
  // Wait for data to be received
  status = UCSR0A;
  while (!(status & (1 << RXC0))) { return -1; }

  // Get status and 9th bit, then data
  resh = UCSR0B;
  resl = UDR0;

  //If error, return -1 
  if (status & ((1 << FE0) | (1 << DOR0) | (1 << UPE0))) { return -1; }

  // Filter the 9th bit, then return 
  resh = (resh >> 1) & 0x01;
  return ((resh << 8) | resl);
}

//--------------------------------------------------------------------------------------------
void USART_Transmit(unsigned char data8) {
 // wait for empty transmit buffer
 while (!(UCSR0A & (1<<UDRE0))) {}
 // put the data into buffer, and send 
 UDR0 = data8;
}

//--------------------------------------------------------------------------------------------
// Interrupt handling
inline void handle_interrupt() {

  unsigned int rxdata = USART_Receive();

  if (rxdata != -1) {		//Data was received correctly?
    if (rxdata >= 0x100) {       //New message begin
      ReadData = false;		//No storing of Serial Data
      if (rxdata == 0x1DE) {      //This is a Call Byte
        XNetclear();               //Delete old message
        ReadData = true;           //Enable data reception
      }
    }
    if (ReadData == true) {      //Data are for ?
      XNetMsg[XNetlength]++;      //more news Loading
      XNetMsg[XNetMsg[XNetlength]] = rxdata; //Enter
    }
    if (XNetMsg[0] == 3 && (XNetMsg[2] == 0xFC || XNetMsg[2] == 0xFB) && XNetMsg[3] == group) //Group_0 - XNetMsg[3] == 0x00, Group_1 - XNetMsg[3] == 0x10
    { 
      for(byte i = 0; i < 10; i++) {
        delayMicroseconds(10);  // PAUSE
        XNetsend(StatusByte[i]);
      }
      XNetclear();
      ReadData = false;
      sfb = true;
    }
  }
}
//--------------------------------------------------------------------------------------------
// send byte to the Command Station
void XNetsend(byte databyte) {
  delayMicroseconds(3);
  digitalWrite (MAX485_CONTROL, HIGH);
  delayMicroseconds(3);
  USART_Transmit (databyte);
  WAIT_FOR_XMIT_COMPLETE;
  digitalWrite (MAX485_CONTROL, LOW);
} 
